/************************************************************************
 *
 * Copyright (C) 2004-2015 IRCAD France
 * Copyright (C) 2012-2015 IHU Strasbourg
 *
 * This file is part of Sight.
 *
 * Sight is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Sight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sight. If not, see <https://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

#ifndef __FWATOMS_NAMESPACE_HPP__
#define __FWATOMS_NAMESPACE_HPP__

/**
 * @namespace   fwAtoms
 *
 *@brief fwAtoms contains basic objects to represent any other kind of object
 *
 * fwAtoms contains seven basic types :
 * \li  Numeric : real and integer type.
 * \li  Boolean : boolean type.
 * \li  String  : String type.
 * \li  Object : complex type.
 * \li  Map : string:Atom association
 * \li  Sequence : sequence of simple Atoms (Numeric, Boolean, String).
 * \li  Blob: representing a raw buffer.
 */
namespace fwAtoms
{
}

#endif /* __FWATOMS_NAMESPACE_HPP__ */

