/************************************************************************
 *
 * Copyright (C) 2017 IRCAD France
 * Copyright (C) 2017 IHU Strasbourg
 *
 * This file is part of Sight.
 *
 * Sight is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Sight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sight. If not, see <https://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

#ifndef __FWDICOMIOFILTER_CONFIG_HPP__
#define __FWDICOMIOFILTER_CONFIG_HPP__

    // This helps to override the log level when using PCH
    #if defined(FWDICOMIOFILTER_EXPORTS) && !defined(SPYLOG_NO_INCLUDE)
        #include "spyLogLevel.hpp"
    #endif

    #ifdef _WIN32

        #ifdef FWDICOMIOFILTER_EXPORTS
            #define FWDICOMIOFILTER_API __declspec(dllexport)
            #define FWDICOMIOFILTER_CLASS_QT_API __declspec(dllexport)
        #else
            #define FWDICOMIOFILTER_API __declspec(dllimport)
            #define FWDICOMIOFILTER_CLASS_QT_API __declspec(dllimport)
        #endif

        #define FWDICOMIOFILTER_CLASS_API
        #define FWDICOMIOFILTER_QT_API

        #pragma warning(disable: 4290)

    #elif defined(__GNUC__) && (__GNUC__>=4)

        #define FWDICOMIOFILTER_API __attribute__ ((visibility("default")))
        #define FWDICOMIOFILTER_CLASS_API __attribute__ ((visibility("default")))

        #define FWDICOMIOFILTER_QT_API __attribute__ ((visibility("default")))
        #define FWDICOMIOFILTER_CLASS_QT_API __attribute__ ((visibility("default")))

    #else

        #define FWDICOMIOFILTER_API
        #define FWDICOMIOFILTER_CLASS_API
        #define FWDICOMIOFILTER_QT_API
        #define FWDICOMIOFILTER_CLASS_QT_API

    #endif

#endif // __FWDICOMIOFILTER_CONFIG_HPP__
