/************************************************************************
 *
 * Copyright (C) 2009-2017 IRCAD France
 * Copyright (C) 2012-2017 IHU Strasbourg
 *
 * This file is part of Sight.
 *
 * Sight is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Sight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sight. If not, see <https://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

#ifndef __FWGUI_CONTAINER_FWCONTAINER_HPP__
#define __FWGUI_CONTAINER_FWCONTAINER_HPP__

#include "fwGui/config.hpp"
#include "fwGui/GuiBaseObject.hpp"

namespace fwGui
{
namespace container
{
/**
 * @brief   Defines the generic container for IHM.
 *
 */
class FWGUI_CLASS_API fwContainer : public ::fwGui::GuiBaseObject
{

public:

    fwCoreNonInstanciableClassDefinitionsMacro( (fwContainer)(::fwGui::GuiBaseObject) );

    FWGUI_API virtual void clean()            = 0;
    FWGUI_API virtual void destroyContainer() = 0;
    FWGUI_API virtual bool isShownOnScreen()  = 0;

    FWGUI_API virtual void setVisible(bool isVisible) = 0;
    FWGUI_API virtual void setEnabled(bool isEnabled) = 0;

};

} // namespace container
} // namespace fwGui

#endif /*__FWGUI_CONTAINER_FWCONTAINER_HPP__*/

